From 58d8132a4221506786b0aaddb44288598aa7b608 Mon Sep 17 00:00:00 2001
From: Nils Philippsen <nils@redhat.com>
Date: Jan 18 2018 16:36:31 +0000
Subject: [PATCH 33/48] migrate ModuleAPI to TreeObj/RPMsMixin


---

diff --git a/modulemd/api.py b/modulemd/api.py
index 3821daf..29ce080 100644
--- a/modulemd/api.py
+++ b/modulemd/api.py
@@ -22,78 +22,22 @@
 #
 # Written by Petr Šabata <contyk@redhat.com>
 
-supported_content = ("rpms",)
+from .legacy_wrappers import TreeObj, RPMsMixin
 
-from gi.repository import Modulemd
 
-class ModuleAPI(object):
+supported_content = ('rpms',)
+
+
+class ModuleAPI(TreeObj, RPMsMixin):
     """Class representing a particular module API."""
 
-    def __init__(self, parent=None):
-        """Creates a new ModuleAPI instance."""
-        self.rpms = set()
-        self.parent = parent
+    tree_identity = 'api'
 
     def __repr__(self):
         return "<ModuleAPI: rpms: {!r}>".format(sorted(self.rpms))
 
-    def __bool__(self):
-        return True if self.rpms else False
-
-    __nonzero__ = __bool__
-
-    @property
-    def rpms(self):
-        """A set of binary RPM packages defining this module's API."""
-        return self._rpms
-
-    @rpms.setter
-    def rpms(self, ss):
-        if not isinstance(ss, set):
-            raise TypeError("api.rpms: data type not supported")
-        for v in ss:
-            if not isinstance(v, str):
-                raise TypeError("api.rpms: data type not supported")
-        self._rpms = ss
-
-        if hasattr(self, 'parent'):
-            ss = Modulemd.SimpleSet()
-            ss.set(list(self.rpms))
-            self.parent.module.set_rpm_api(ss)
-
-    def add_rpm(self, s):
-        """Adds a binary RPM package to the API set.
-
-        :param str s: Binary RPM package name
-        """
-        if not isinstance(s, str):
-            raise TypeError("api.add_rpm: data type not supported")
-        self._rpms.add(s)
-
-        if hasattr(self, 'parent'):
-            ss = Modulemd.SimpleSet()
-            ss.set(list(self.rpms))
-            self.parent.module.set_rpm_api(ss)
-
-    def del_rpm(self, s):
-        """Removes the supplied package name from the API package set.
-
-        :param str s: Binary RPM package name
-        """
-        if not isinstance(s, str):
-            raise TypeError("api.del_rpm: data type not supported")
-        self._rpms.discard(s)
-
-        if hasattr(self, 'parent'):
-            ss = Modulemd.SimpleSet()
-            ss.set(list(self.rpms))
-            self.parent.module.set_rpm_api(ss)
-
-    def clear_rpms(self):
-        """Clear the API binary RPM package set."""
-        self._rpms.clear()
+    def get_rpm_set(self):
+        return self.parent.module.get_rpm_api()
 
-        if hasattr(self, 'parent'):
-            ss = Modulemd.SimpleSet()
-            ss.set(list(self.rpms))
-            self.parent.module.set_rpm_api(ss)
+    def set_rpm_set(self, ss):
+        self.parent.module.set_rpm_api(ss)

